"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .customcontrolsmetadataresponsedto import (
    CustomControlsMetadataResponseDto,
    CustomControlsMetadataResponseDtoTypedDict,
)
from .stepissuesdto import StepIssuesDto, StepIssuesDtoTypedDict
from .steptypeenum import StepTypeEnum
from .workfloworiginenum import WorkflowOriginEnum
from novu_py.types import BaseModel
import pydantic
from pydantic import ConfigDict
from typing import Any, Dict, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class CustomStepResponseDtoControlValuesTypedDict(TypedDict):
    r"""Control values for the custom step"""

    custom: NotRequired[Dict[str, Any]]
    r"""Custom control values for the step."""


class CustomStepResponseDtoControlValues(BaseModel):
    r"""Control values for the custom step"""

    model_config = ConfigDict(
        populate_by_name=True, arbitrary_types_allowed=True, extra="allow"
    )
    __pydantic_extra__: Dict[str, Any] = pydantic.Field(init=False)

    custom: Optional[Dict[str, Any]] = None
    r"""Custom control values for the step."""

    @property
    def additional_properties(self):
        return self.__pydantic_extra__

    @additional_properties.setter
    def additional_properties(self, value):
        self.__pydantic_extra__ = value  # pyright: ignore[reportIncompatibleVariableOverride]


class CustomStepResponseDtoSlugTypedDict(TypedDict):
    r"""Slug of the step"""


class CustomStepResponseDtoSlug(BaseModel):
    r"""Slug of the step"""


class CustomStepResponseDtoTypedDict(TypedDict):
    controls: CustomControlsMetadataResponseDtoTypedDict
    r"""Controls metadata for the custom step"""
    variables: Dict[str, Any]
    r"""JSON Schema for variables, follows the JSON Schema standard"""
    step_id: str
    r"""Unique identifier of the step"""
    id: str
    r"""Database identifier of the step"""
    name: str
    r"""Name of the step"""
    slug: CustomStepResponseDtoSlugTypedDict
    r"""Slug of the step"""
    type: StepTypeEnum
    r"""Type of the step"""
    origin: WorkflowOriginEnum
    r"""Origin of the workflow"""
    workflow_id: str
    r"""Workflow identifier"""
    workflow_database_id: str
    r"""Workflow database identifier"""
    control_values: NotRequired[CustomStepResponseDtoControlValuesTypedDict]
    r"""Control values for the custom step"""
    issues: NotRequired[StepIssuesDtoTypedDict]
    r"""Issues associated with the step"""


class CustomStepResponseDto(BaseModel):
    controls: CustomControlsMetadataResponseDto
    r"""Controls metadata for the custom step"""

    variables: Dict[str, Any]
    r"""JSON Schema for variables, follows the JSON Schema standard"""

    step_id: Annotated[str, pydantic.Field(alias="stepId")]
    r"""Unique identifier of the step"""

    id: Annotated[str, pydantic.Field(alias="_id")]
    r"""Database identifier of the step"""

    name: str
    r"""Name of the step"""

    slug: CustomStepResponseDtoSlug
    r"""Slug of the step"""

    type: StepTypeEnum
    r"""Type of the step"""

    origin: WorkflowOriginEnum
    r"""Origin of the workflow"""

    workflow_id: Annotated[str, pydantic.Field(alias="workflowId")]
    r"""Workflow identifier"""

    workflow_database_id: Annotated[str, pydantic.Field(alias="workflowDatabaseId")]
    r"""Workflow database identifier"""

    control_values: Annotated[
        Optional[CustomStepResponseDtoControlValues],
        pydantic.Field(alias="controlValues"),
    ] = None
    r"""Control values for the custom step"""

    issues: Optional[StepIssuesDto] = None
    r"""Issues associated with the step"""
