"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .steptypeenum import StepTypeEnum
from enum import Enum
from novu_py.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
import pydantic
from pydantic import model_serializer
from typing import Any, Dict, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class DelayStepUpsertDtoType(str, Enum):
    r"""Type of the delay. Currently only 'regular' is supported by the schema."""

    REGULAR = "regular"


class DelayStepUpsertDtoUnit(str, Enum):
    r"""Unit of time for the delay amount."""

    SECONDS = "seconds"
    MINUTES = "minutes"
    HOURS = "hours"
    DAYS = "days"
    WEEKS = "weeks"
    MONTHS = "months"


class DelayStepUpsertDtoControlValuesTypedDict(TypedDict):
    r"""Control values for the Delay step"""

    amount: float
    r"""Amount of time to delay."""
    unit: DelayStepUpsertDtoUnit
    r"""Unit of time for the delay amount."""
    skip: NotRequired[Dict[str, Any]]
    r"""JSONLogic filter conditions for conditionally skipping the step execution. Supports complex logical operations with AND, OR, and comparison operators. See https://jsonlogic.com/ for full typing reference."""
    type: NotRequired[DelayStepUpsertDtoType]
    r"""Type of the delay. Currently only 'regular' is supported by the schema."""


class DelayStepUpsertDtoControlValues(BaseModel):
    r"""Control values for the Delay step"""

    amount: float
    r"""Amount of time to delay."""

    unit: DelayStepUpsertDtoUnit
    r"""Unit of time for the delay amount."""

    skip: Optional[Dict[str, Any]] = None
    r"""JSONLogic filter conditions for conditionally skipping the step execution. Supports complex logical operations with AND, OR, and comparison operators. See https://jsonlogic.com/ for full typing reference."""

    type: Optional[DelayStepUpsertDtoType] = DelayStepUpsertDtoType.REGULAR
    r"""Type of the delay. Currently only 'regular' is supported by the schema."""


class DelayStepUpsertDtoTypedDict(TypedDict):
    name: str
    r"""Name of the step"""
    type: StepTypeEnum
    r"""Type of the step"""
    id: NotRequired[str]
    r"""Unique identifier of the step"""
    control_values: NotRequired[Nullable[DelayStepUpsertDtoControlValuesTypedDict]]
    r"""Control values for the Delay step"""


class DelayStepUpsertDto(BaseModel):
    name: str
    r"""Name of the step"""

    type: StepTypeEnum
    r"""Type of the step"""

    id: Annotated[Optional[str], pydantic.Field(alias="_id")] = None
    r"""Unique identifier of the step"""

    control_values: Annotated[
        OptionalNullable[DelayStepUpsertDtoControlValues],
        pydantic.Field(alias="controlValues"),
    ] = UNSET
    r"""Control values for the Delay step"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["_id", "controlValues"]
        nullable_fields = ["controlValues"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
